package models.jcommon.blob;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.FileTime;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Random;
import java.util.UUID;

import models.jcommon.db.base.BaseModel;
import models.jcommon.util.DateUtil;

import org.apache.commons.codec.binary.Hex;
import org.apache.commons.lang.time.StopWatch;


import play.Logger;
import play.db.jdbc.Query;

public class BlobTableDao extends BlobTable {
	
	/**List all BlobTable with this id_content 	 
	 * @param id_content
	 * @return
	 */
	public static List<BlobTable> listById(Long id_content)
	{
		return find("blb_id_content=? order by blb_versi", id_content).fetch();
	}	
	
	/** Get last BlobTable for this id_content  
	 * @param id_content
	 * @return
	 */
	public static BlobTable getLastById(Long id_content)
	{
		return find("blb_id_content=? order by blb_versi desc", id_content).first();
	}
	
	/**
	 * Save file to blob.
	 * gunakan untuk menyimpan file baru
	 * @param mode
	 * @param file
	 * @return
	 * @throws SQLException 
	 */
	public static BlobTable saveFile(BlobTable.ARCHIEVE_MODE mode, File file) throws Exception 
	{
		Long id=BaseModel.getNextSequenceValue("seq_epns");
		
		return saveFile(mode, file, id);
	}
	
	/**
	 * Save file to blob.
	 * @param mode
	 * @param 
	 * @return
	 * @throws SQLException 
	 */
	public static BlobTable saveInputStream(BlobTable.ARCHIEVE_MODE mode, InputStream is, String fileName) throws Exception 
	{
		Long id=BaseModel.getNextSequenceValue("seq_epns");
		return saveFile(mode, null, is, id, fileName);
	}
	
	/*If uploads many files at once, it may occur
	 * Message "INFO Waiting for Writing..."
	 * Generated by class: com.ning.http.multipart.MultipartBody 
	 */
	
	private static BlobTable saveFile(ARCHIEVE_MODE mode, File file, InputStream is, Long id_content, String fileName) throws Exception{
		
		BlobTable blob=new BlobTable();		
		blob.blb_engine=BlobTable.ENGINE_VERSION;
		if(id_content == null)
			id_content = getNextSequenceValue("seq_epns");
		blob.blb_id_content=id_content;
		blob.blb_mirrored=0;
		
		String[] result=saveFileReturnArray(mode, file, is);
		
		String path=result[0];		
		if(file==null)
		{
			file=new File(getFileStorageDir() + path);
			blob.blb_nama_file=fileName;
			
		}
		else{
			
			blob.blb_nama_file=file.getName();

		}

		blob.blb_hash=result[1];
		String ukuran=result[2];
	
					
		//final path (encrypted)
		String encPath= encryptPathInfo(path, blob.blb_hash, blob.blb_nama_file, ukuran); 
		blob.blb_path=encPath;
		//dapatkan versi berikutnya
		blob.blb_versi=nextVersi(id_content);
	
		blob.blb_date_time=new Date();
		
		Logger.debug("[Save Blob Table] @end id content %s, ukuran, %s", blob.blb_id_content, result[2]);
		///save() must be last code (if error while save to disk, TABLE is not saved)
		blob.save();
		blob.postLoad(); //panggil postLoad untuk mengisi field-field yang Transient
		return blob;
	}

	/**Save file for specific id_content.
	 * Pastikan di struktur table sbb
	 * blb_date_time is nullable
	 * blb_path panjangnya 10240 
	 * @throws Exception 
	 */
	public static BlobTable saveFile(BlobTable.ARCHIEVE_MODE mode, File file, Long id_content) throws Exception 
	{
		return saveFile(mode, file, null, id_content, null);
	}
	
	/*** Lakukan enkripsi terhadap path info. Hasilnya akan diset ke blb_path */
	public static String encryptPathInfo(String path, String md5Value, String fileName, String fileLength)
	{
		String str=path + "\n" + md5Value + "\n" + fileName + "\n" + fileLength + "\n" + DateUtil.newDate().getTime();
		str=BaseModel.encrypt(str);
		return str;
	}
	
	/**Simpan file atau inputSteam (salah satu)
	 * 
	 * @param mode
	 * @param file File to save
	 * @param is InputStream to save (salah satu)
	 * @return {path, md5Value, String.valueOf(fileSize)}
	 * @throws NoSuchAlgorithmException
	 * @throws IOException
	 */
	private static String[] saveFileReturnArray(ARCHIEVE_MODE mode, File file, InputStream is) throws NoSuchAlgorithmException, IOException
	{
		StopWatch dt=new StopWatch();
		dt.start();
//		 * File blb_path berisi sbb
//		 * [path,hash,name,size,date_created] (separated by \n) 
//		 * date_created format is in long
//	
		/* Dapatkan path untuk menyimpan file
		 * Path sbb:
		 *  /ARCHIEVE_MODE/TAHUN/xx/uuid
		 *  ARCHIEVE_MODE: 0=arhivable, 1=non-archievable
		 *  TAHUN: 4 digit
		 *  xxx: random 3 digit
		 *  uuid: random
		 */
		Calendar cak=new GregorianCalendar();
		String path="/" + mode.value + "/" + cak.get(Calendar.YEAR);
		String uuid=UUID.randomUUID().toString();
		path=path + "/" + uuid.substring(0,3);		
		
		//create dirs
		String baseDir=getFileStorageDir();
		if(baseDir==null)
			throw new IOException(FILE_STORAGE_DIR + " was not defined.");
		File parentDir=new File(baseDir + path);
		parentDir.mkdirs();
		
		//location file to save
		path=path + "/" + uuid.substring(3);
		File storage=new File(getFileStorageDir() + path);
		
		//copy file. While copying and compute MD5 & encrypt
	
			//1. prepare Cipher (untuk sementara fungsi encryt tidak diaktifkan. Nggak tahu kapan diaktifkan)
//			 byte[] raw = privateKey.getBytes();
//            SecretKeySpec skeySpec = new SecretKeySpec(raw, "Blowfish");
//            Cipher cipher = Cipher.getInstance("Blowfish");
//            cipher.init(Cipher.DECRYPT_MODE, skeySpec); 
//			
			//2. prepare digest			
		MessageDigest md= MessageDigest.getInstance("MD5");
		
		//copy
		FileOutputStream out=new FileOutputStream(storage);
		InputStream in = null;
		//Pilih salah satu dari File atau inputstream
		if(file!=null) 
			in=new FileInputStream(file);
		 else
			in=is;
		byte buffer[]=new byte[1024 * 10];
		int size;
		while((size=in.read(buffer))!=-1)
		{
			out.write(buffer, 0, size);
			md.update(buffer, 0, size);
		}
		byte[] digest=md.digest();
		out.close();
		in.close();
		String md5Value= String.valueOf(Hex.encodeHex(digest));
		dt.stop();
		long fileSize=storage.length();

		/** Mod-time, access-time, & create-time untuk file & folder-nya
		 * dibuat acak mulai tanggal 1-1-2013 sampai hari ini
		 */
		
		
		Path[] paths=new Path[]{Paths.get(storage.getAbsolutePath()), 
				Paths.get(storage.getParentFile().getAbsolutePath())};
		
		Random random=new Random();
		for(Path nioPath: paths)
		{	
			Files.setAttribute(nioPath, "basic:lastModifiedTime", createRandomTime(random));
			Files.setAttribute(nioPath, "basic:lastAccessTime", createRandomTime(random));
			Files.setAttribute(nioPath, "basic:creationTime", createRandomTime(random));
		}
		
			
		//delete original file
		if(file!=null)
			file.delete();
//		Logger.debug("Save blob_table. FileName: %s, filePath: %s, size: %s, save duration %s",	file.getName() , path, file.length(), dt.toString());			
		return new String[] {path, md5Value, String.valueOf(fileSize)};
	}
	
	private static FileTime createRandomTime(Random random)
	{
		long startDate=new GregorianCalendar(2013, 1, 1).getTimeInMillis();
		long endDate=new Date().getTime();
		long diff=endDate-startDate;
		long randomTime=(random.nextLong())%diff;
		randomTime+=startDate;
		FileTime time= java.nio.file.attribute.FileTime.fromMillis(randomTime);
		return time;
	}
	
	/**
	 * @return String[] = [path, Md5, size] 
	 */
	
	public static String[] saveFileReturnArray(ARCHIEVE_MODE mode, File file) throws NoSuchAlgorithmException, IOException
	{
		
		return saveFileReturnArray(mode, file, null);
	}
	
	/** Dapatkan versi berikutnya dari id_content.
	 * Jika id_content baru maka nextVersi=0*/
	protected synchronized static Integer nextVersi(long id_content) {
		Integer value=Query.find("select max(blb_versi) from blob_table where blb_id_content=? ",Integer.class, id_content).first();
		if(value==null)
			return 0;
		else
			return value.intValue()+1;
	}

	/** Find by id, which is encrypted*/
	public static BlobTable findById(String id)
	{
		BlobTableSecureId secId=new BlobTableSecureId(id);
		return findById(secId.id_content, secId.versi);
	}

	

}
